diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index 57433468e..240f39051 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -1336,48 +1228,50 @@ public class World implements WorldSource {
         playSoundEffect(player, SoundCategory.WORLD_SOUNDS, x, y, z, name, soundType.modifyVolume(sound.getVolume()), soundType.modifyPitch(sound.getPitch()));
     }
 
-    public void playRecord(String soundPath, String author, int x, int y, int z)
-    {
-        for(int l = 0; l < listeners.size(); l++)
-        {
-            listeners.get(l).playStreamingMusic(soundPath, author, x, y, z);
+    public void playRecord(final @Nullable String soundPath, final @Nullable String author, final @NotNull TilePos tilePos) {
+        for (final @NotNull LevelListener listener : listeners) {
+            listener.playStreamingMusic(soundPath, author, tilePos.x, tilePos.y, tilePos.z);
         }
+    }
 
+    @Deprecated
+    public final void playRecord(final @Nullable String soundPath, final @Nullable String author, final int x, final int y, final int z) {
+        this.playRecord(soundPath, author, new TilePos(x, y, z));
     }
 
-    public void spawnParticle(String particleKey, double x, double y, double z,
-                              double motionX, double motionY, double motionZ, int data, double maxDistance)
-    {
-        for(int i = 0; i < listeners.size(); i++)
-        {
-            listeners.get(i).addParticle(particleKey, x, y, z, motionX, motionY, motionZ, data, maxDistance);
+    public void spawnParticle(
+        final @NotNull String particleKey,
+        final double x, final double y, final double z,
+        final double motionX, final double motionY, final double motionZ,
+        final int data,
+        final double maxDistance
+    ) {
+        for (final @NotNull LevelListener listener : this.listeners) {
+            listener.addParticle(particleKey, x, y, z, motionX, motionY, motionZ, data, maxDistance);
         }
-
     }
 
-
-    public void spawnParticle(String particleKey, double x, double y, double z,
-                              double motionX, double motionY, double motionZ, int data)
-    {
-        for(int i = 0; i < listeners.size(); i++)
-        {
-            listeners.get(i).addParticle(particleKey, x, y, z, motionX, motionY, motionZ, data);
+    public void spawnParticle(
+        final @NotNull String particleKey,
+        final double x, final double y, final double z,
+        final double motionX, final double motionY, final double motionZ,
+        final int data
+    ) {
+        for (final @NotNull LevelListener listener : this.listeners) {
+            listener.addParticle(particleKey, x, y, z, motionX, motionY, motionZ, data);
         }
-
     }
 
-    public boolean addWeatherEffect(Entity entity)
-    {
-        weatherEffects.add(entity);
+    public boolean addWeatherEffect(final @NotNull Entity entity) {
+        this.weatherEffects.add(entity);
         return true;
     }
 
-    public void addRainbow(int rainbowTicks){
-        this.rainbowTicks = startingRainbowTicks = rainbowTicks;
+    public void addRainbow(final int rainbowTicks){
+        this.rainbowTicks = this.startingRainbowTicks = rainbowTicks;
     }
 
-    public boolean entityJoinedWorld(Entity entity)
-    {
+    public boolean entityJoinedWorld(Entity entity) {
         int i = MathHelper.floor(entity.x / Chunk.CHUNK_SIZE_X);
         int j = MathHelper.floor(entity.z / Chunk.CHUNK_SIZE_Z);
         boolean flag = entity instanceof Player;
@@ -1645,14 +1539,19 @@ public class World implements WorldSource {
         return f2 * f2 * 0.5F;
     }
 
-    public void scheduleBlockUpdate(int x, int y, int z, int id, long delay) {
-        this.scheduleBlockUpdate(x, y, z, id, delay, false);
+    public final void scheduleBlockUpdate(final @NotNull TilePos tilePos, final int id, final long delay) {
+        this.scheduleBlockUpdate(tilePos, id, delay, false);
+    }
+
+    @Deprecated
+    public final void scheduleBlockUpdate(final int x, final int y, final int z, final int id, final long delay) {
+        this.scheduleBlockUpdate(new TilePos(x, y, z), id, delay);
     }
 
-    public void scheduleBlockUpdate(int x, int y, int z, int id, long delay, boolean loaded) {
-        NextTickListEntry entry = new NextTickListEntry(x, y, z, id, getWorldTime());
+    public void scheduleBlockUpdate(final @NotNull TilePos tilePos, final int id, final long delay, final boolean loaded) {
+        NextTickListEntry entry = new NextTickListEntry(tilePos.x, tilePos.y, tilePos.z, id, getWorldTime());
         entry.loaded = loaded;
-        byte radius = 8;
+        final byte radius = 8;
 
         if(scheduledUpdatesAreImmediate && !immediatelyUpdatedPositions.contains(entry)) {
             if(entry.loaded || areBlocksLoaded(entry.x - radius, entry.y - radius, entry.z - radius, entry.x + radius, entry.y + radius, entry.z + radius)) {
@@ -1664,17 +1563,23 @@ public class World implements WorldSource {
             }
             return;
         }
-        if(entry.loaded || areBlocksLoaded(x - radius, y - radius, z - radius, x + radius, y + radius, z + radius)) {
+        if(entry.loaded || areBlocksLoaded(tilePos, radius)) {
             if(id > 0) {
                 entry.setDelay(delay);
             }
             if(!tickNextTickList.contains(entry)) {
                 tickNextTickList.add(entry);
-                final @NotNull Chunk chunk = Objects.requireNonNull(this.getChunkFromBlockCoords(x, z));
+                final @NotNull Chunk chunk = Objects.requireNonNull(this.getChunk(tilePos));
                 chunk.addTick(entry);
             }
         }
     }
+
+    @Deprecated
+    public final void scheduleBlockUpdate(final int x, final int y, final int z, final int id, final long delay, final boolean loaded) {
+        this.scheduleBlockUpdate(new TilePos(x, y, z), id, delay, loaded);
+    }
+
     public void updateEntities()
     {
         for(int i = 0; i < weatherEffects.size(); i++)
@@ -1735,7 +1640,7 @@ public class World implements WorldSource {
             releaseEntitySkin(entity2);
         }
 
-        updatingBlockEntities = true;
+        updatingTileEntities = true;
         for (int i = tileEntityList.size() - 1; i >= 0; i--) {
             TileEntity tileEntity = tileEntityList.get(i);
             if (!tileEntity.isInvalid() && isBlockLoaded(tileEntity.x, tileEntity.y, tileEntity.z)) {
@@ -1749,7 +1654,7 @@ public class World implements WorldSource {
                 }
             }
         }
-        updatingBlockEntities = false;
+        updatingTileEntities = false;
     }
 
     public void addAllBlockEntities(Collection<TileEntity> blockEntities)
@@ -1767,7 +1672,7 @@ public class World implements WorldSource {
         int i = MathHelper.floor(entity.x);
         int j = MathHelper.floor(entity.z);
         byte byte0 = 32;
-        if(flag && !areBlocksLoaded(i - byte0, 0, j - byte0, i + byte0, getHeightBlocks(), j + byte0))
+        if(flag && !areBlocksLoaded(i - byte0, 0, j - byte0, i + byte0, getHeightBlocks() - 1, j + byte0))
         {
             //try to despawn if entity wanders into nonexistant chunk
             if(entity instanceof Mob) {
@@ -2114,18 +2019,21 @@ public class World implements WorldSource {
         return (float)i / (float)j;
     }
 
-    public void onBlockHit(Player entityplayer, int x, int y, int z, Side side)
-    {
-        x += side.getOffsetX();
-        y += side.getOffsetY();
-        z += side.getOffsetZ();
-        if(getBlockId(x, y, z) == Blocks.FIRE.id() || getBlockId(x, y, z) == Blocks.FIRE_COLD.id())
-        {
-            playBlockEvent(entityplayer, LevelListener.EVENT_FIRE_EXTINGUISH, x, y, z, 0);
-            setBlockWithNotify(x, y, z, 0);
+    public void onBlockHit(final @NotNull Player player, final @NotNull TilePos tilePos, final @NotNull Side side) {
+        final @NotNull TilePos offsetPos = tilePos.add(side.getDirection());
+        final @Nullable Block<?> block = this.getBlock(offsetPos);
+
+        if (block == Blocks.FIRE || block == Blocks.FIRE_COLD) {
+            this.playBlockEvent(player, offsetPos, LevelListener.EVENT_FIRE_EXTINGUISH, 0);
+            this.setBlockIdNotify(tilePos, 0);
         }
     }
 
+    @Deprecated
+    public final void onBlockHit(final @NotNull Player player, final int x, final int y, final int z, final @NotNull Side side) {
+        this.onBlockHit(player, new TilePos(x, y, z), side);
+    }
+
     public @Nullable Entity getEntityByID(int id)
     {
         for(int i = 0; i < entities.size(); i++)
@@ -2151,107 +2059,80 @@ public class World implements WorldSource {
     }
 
     @Override
-    public TileEntity getTileEntity(int x, int y, int z)
-    {
-        Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z));
-        if(chunk != null)
-        {
-            return chunk.getTileEntity(x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1));
-        } else
-        {
-            return null;
-        }
+    public @Nullable TileEntity getTileEntity(final @NotNull TilePos tilePos) {
+        final @NotNull Chunk chunk = this.getChunk(tilePos);
+        return chunk.getTileEntity(tilePos.toChunkTilePos());
     }
 
-    public void setTileEntity(int x, int y, int z, TileEntity tileEntity)
-    {
-        if(!tileEntity.isInvalid())
-        {
-            Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z));
-            if(chunk != null)
-            {
-                if (chunk.setTileEntity(x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1), tileEntity) && !tileEntityList.contains(tileEntity)) {
-                    tileEntityList.add(tileEntity);
-                }
+    @Override
+    public void setTileEntity(final @NotNull TilePos tilePos, final @NotNull TileEntity tileEntity) {
+        if (!tileEntity.isInvalid()) {
+            if (this.getChunk(tilePos).setTileEntity(tilePos.toChunkTilePos(), tileEntity) && !this.tileEntityList.contains(tileEntity)) {
+                this.tileEntityList.add(tileEntity);
             }
         }
     }
 
-    public void removeBlockTileEntity(int x, int y, int z)
-    {
-        TileEntity tileEntity = getTileEntity(x, y, z);
+    @Override
+    public void removeTileEntity(final @NotNull TilePos tilePos) {
+        final @Nullable TileEntity tileEntity = this.getTileEntity(tilePos);
 
-        if(tileEntity != null && updatingBlockEntities)
-        {
+        if (tileEntity != null && this.updatingTileEntities) {
             tileEntity.invalidate();
-        } else
-        {
-            if(tileEntity != null)
-            {
-                tileEntityList.remove(tileEntity);
-            }
-            Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z));
-            if(chunk != null)
-            {
-                chunk.removeTileEntity(tileEntity);
+        } else {
+            if (tileEntity != null) {
+                this.tileEntityList.remove(tileEntity);
             }
+
+            this.getChunk(tilePos).removeTileEntity(tileEntity);
         }
     }
 
-    public void replaceBlockTileEntity(int x, int y, int z, TileEntity tileEntity) {
-        removeBlockTileEntity(x, y, z);
-        setTileEntity(x, y, z, tileEntity);
+    @Override
+    public boolean isBlockOpaqueCube(final @NotNull TilePos tilePos) {
+        final @Nullable Block<?> block = this.getBlock(tilePos);
+        return block != null && block.isSolidRender();
     }
 
-    @Override
-    public boolean isBlockOpaqueCube(int x, int y, int z)
-    {
-        Block<?> block = Blocks.blocksList[getBlockId(x, y, z)];
-        if(block == null)
-        {
-            return false;
-        } else
-        {
-            return block.isSolidRender();
-        }
+    public boolean canPlaceOnSurfaceOfBlock(final @NotNull TilePos tilePos) {
+        final @Nullable Block<?> block = this.getBlock(tilePos);
+        return block != null && block.canPlaceOnSurfaceOnCondition(this, tilePos.x, tilePos.y, tilePos.z);
     }
 
-    public boolean canPlaceOnSurfaceOfBlock(int x, int y, int z)
-    {
-        Block<?> block = Blocks.blocksList[getBlockId(x, y, z)];
-        if(block == null)
-        {
-            return false;
-        } else
-        {
-            return block.canPlaceOnSurfaceOnCondition(this, x, y, z);
+    @Deprecated
+    public final boolean canPlaceOnSurfaceOfBlock(final int x, final int y, final int z) {
+        return this.canPlaceOnSurfaceOfBlock(new TilePos(x, y, z));
+    }
+
+    public @NotNull ISupport getSupport(final @NotNull TilePos tilePos, final @NotNull Side side) {
+        final @Nullable Block<?> block = this.getBlock(tilePos);
+        if (block == null) {
+            return PartialSupport.INSTANCE;
         }
+
+        return block.getSupport(this, tilePos.x, tilePos.y, tilePos.z, side);
     }
 
-    public @NotNull ISupport getSupport(int x, int y, int z, @NotNull Side side) {
-        Block<?> b = getBlock(x, y, z);
-        if (b == null) return PartialSupport.INSTANCE;
-        return b.getSupport(this, x, y, z, side);
+    @Deprecated
+    public final @NotNull ISupport getSupport(final int x, final int y, final int z, final @NotNull Side side) {
+        return this.getSupport(new TilePos(x, y, z), side);
     }
 
     @Override
-    public boolean isBlockNormalCube(int x, int y, int z)
-    {
-        // Determines if you suffocate in a block, among other things
-        Block<?> block = Blocks.blocksList[getBlockId(x, y, z)];
-        if(block == null)
-        {
-            return false;
-        } else
-        {
-            return block.getMaterial().isSolidBlocking() && block.renderAsNormalBlockOnCondition(this, x, y, z);
-        }
+    public boolean isBlockNormalCube(final @NotNull TilePos tilePos) {
+        // Determines if you suffocate in a block, among other things.
+        final @Nullable Block<?> block = this.getBlock(tilePos);
+        return block != null && block.getMaterial().isSolidBlocking() && block.renderAsNormalBlockOnCondition(this, tilePos.x, tilePos.y, tilePos.z);
+    }
+
+    public boolean canPlaceInsideBlock(final @NotNull TilePos tilePos) {
+        final @Nullable Block<?> block = this.getBlock(tilePos);
+        return block == null || block.hasTag(BlockTags.PLACE_OVERWRITES);
     }
-    
-    public boolean canPlaceInsideBlock(int x, int y, int z) {
-        int id = getBlockId(x, y, z);
 
-        return id == 0 || Blocks.getBlock(id).hasTag(BlockTags.PLACE_OVERWRITES);
+    @Deprecated
+    public final boolean canPlaceInsideBlock(final int x, final int y, final int z) {
+        return this.canPlaceInsideBlock(new TilePos(x, y, z));
     }
 
     public void onUnload()
@@ -2278,9 +2159,25 @@ public class World implements WorldSource {
         return this.lightingEngine.updatingLighting();
     }
 
-    public void scheduleLightingUpdate(final LightLayer layer, final int minX, final int minY, final int minZ, final int maxX, final int maxY, final int maxZ)
-    {
-        this.lightingEngine.scheduleLightingUpdate(layer, minX, minY, minZ, maxX, maxY, maxZ);
+    public void scheduleLightingUpdate(final @NotNull LightLayer lightLayer, final @NotNull TilePos tilePos) {
+        this.scheduleLightingUpdate(lightLayer, tilePos, tilePos);
+    }
+
+    public void scheduleLightingUpdate(final @NotNull LightLayer lightLayer, final @NotNull TilePos min, final @NotNull TilePos max) {
+        this.lightingEngine.scheduleLightingUpdate(
+            lightLayer,
+            Math.min(min.x, max.x),
+            Math.min(min.y, max.y),
+            Math.min(min.z, max.z),
+            Math.max(min.x, max.x),
+            Math.max(min.y, max.y),
+            Math.max(min.z, max.z)
+        );
+    }
+
+    @Deprecated
+    public final void scheduleLightingUpdate(final @NotNull LightLayer lightLayer, final int minX, final int minY, final int minZ, final int maxX, final int maxY, final int maxZ) {
+        this.scheduleLightingUpdate(lightLayer, new TilePos(minX, minY, minZ), new TilePos(maxX, maxY, maxZ));
     }
 
     public void updateSkyBrightness()
@@ -2497,21 +2394,27 @@ public class World implements WorldSource {
         return !tickNextTickList.isEmpty();
     }
 
-    public void randomDisplayUpdates(int x, int y, int z)
-    {
-        final byte radius = 16;
-        Random random = new Random();
-        for(int i = 0; i < ANIMATION_TICKS_PER_TICK; i++)
-        {
-            int rx = (x + rand.nextInt(radius)) - rand.nextInt(radius);
-            int ry = (y + rand.nextInt(radius)) - rand.nextInt(radius);
-            int rz = (z + rand.nextInt(radius)) - rand.nextInt(radius);
-            Block<?> block = getBlock(rx, ry, rz);
+    public void randomDisplayUpdates(final @NotNull TilePos tilePos) {
+        final int radius = 16;
+        final @NotNull Random random = new Random();
+
+        for(int i = 0; i < ANIMATION_TICKS_PER_TICK; i++) {
+            final @NotNull TilePos randomPos = tilePos.add(
+                this.rand.nextInt(radius) - this.rand.nextInt(radius),
+                this.rand.nextInt(radius) - this.rand.nextInt(radius),
+                this.rand.nextInt(radius) - this.rand.nextInt(radius)
+            );
+
+            final @Nullable Block<?> block = this.getBlock(randomPos);
             if (block != null) {
-                block.animationTick(this, rx, ry, rz, random);
+                block.animationTick(this, randomPos.x, randomPos.y, randomPos.z, random);
             }
         }
+    }
 
+    @Deprecated
+    public final void randomDisplayUpdates(final int x, final int y, final int z) {
+        this.randomDisplayUpdates(new TilePos(x, y, z));
     }
 
     public List<Entity> getEntitiesWithinAABBExcludingEntity(Entity entity, AABB aabb)
@@ -2567,18 +2470,21 @@ public class World implements WorldSource {
         return tileEntityList;
     }
 
-    public void updateTileEntityChunkAndSendToPlayer(int x, int y, int z, TileEntity tileEntity)
-    {
-        if(isBlockLoaded(x, y, z))
-        {
-            getChunkFromBlockCoords(x, z).setChunkModified();
+    public void updateTileEntityChunkAndSendToPlayer(final @NotNull TilePos tilePos, final @NotNull TileEntity tileEntity) {
+        if (this.isBlockLoaded(tilePos)) {
+            this.getChunk(tilePos).setChunkModified();
         }
-        for(int l = 0; l < listeners.size(); l++)
-        {
-            listeners.get(l).tileEntityChanged(x, y, z, tileEntity);
+
+        for (final @NotNull LevelListener listener : this.listeners) {
+            listener.tileEntityChanged(tilePos.x, tilePos.y, tilePos.z, tileEntity);
         }
     }
 
+    @Deprecated
+    public final void updateTileEntityChunkAndSendToPlayer(final int x, final int y, final int z, final @NotNull TileEntity tileEntity) {
+        this.updateTileEntityChunkAndSendToPlayer(new TilePos(x, y, z), tileEntity);
+    }
+
     public int countEntities(Class<?> clazz)
     {
         int i = 0;
@@ -2612,28 +2518,38 @@ public class World implements WorldSource {
         while(chunkProvider.tick());
     }
 
-    public boolean canBlockBePlacedAt(int blockId, int x, int y, int z, boolean flag, Side side)
-    {
-    	if(y < 0 || y >= getHeightBlocks()) {
-    		return false;
-    	}
-        int j1 = getBlockId(x, y, z);
-        Block<?> block = Blocks.blocksList[j1];
-        Block<?> block1 = Blocks.blocksList[blockId];
-        AABB axisalignedbb = block1.getCollisionBoundingBoxFromPool(this, x, y, z);
-        if(flag)
-        {
-            axisalignedbb = null;
+    public boolean canBlockIdBePlacedAt(final int id, final @NotNull TilePos tilePos, final boolean ignoreCollision, final @NotNull Side side) {
+        if (tilePos.y < 0 || tilePos.y >= this.getHeightBlocks()) {
+            return false;
         }
-        if(axisalignedbb != null && !checkIfAABBIsClear(axisalignedbb))
-        {
+
+        final @Nullable Block<?> currentBlock = this.getBlock(tilePos);
+        final @Nullable Block<?> newBlock = Blocks.blocksList[id];
+        if (newBlock == null) {
             return false;
         }
-        if(block != null && block.hasTag(BlockTags.PLACE_OVERWRITES))
-        {
-            block = null;
+
+        final @Nullable AABB bb;
+        if (ignoreCollision) {
+            bb = null;
+        } else {
+            bb = newBlock.getCollisionBoundingBoxFromPool(this, tilePos.x, tilePos.y, tilePos.z);
         }
-        return blockId > 0 && block == null && block1.canPlaceBlockOnSide(this, x, y, z, side);
+
+        if (bb != null && !this.checkIfAABBIsClear(bb)) {
+            return false;
+        }
+
+        if (currentBlock == null || currentBlock.hasTag(BlockTags.PLACE_OVERWRITES)) {
+            return newBlock.canPlaceBlockOnSide(this, tilePos.x, tilePos.y, tilePos.z, side);
+        } else {
+            return false;
+        }
+    }
+
+    @Deprecated
+    public final boolean canBlockBePlacedAt(final int id, final int x, final int y, final int z, final boolean ignoreCollision, final @NotNull Side side) {
+        return this.canBlockIdBePlacedAt(id, new TilePos(x, y, z), ignoreCollision, side);
     }
 
     public @Nullable Path getPathToEntity(Entity entity, Entity entityToTravelTo, float distance)
@@ -2652,62 +2568,74 @@ public class World implements WorldSource {
         return (new PathFinder(chunkcache)).findPath(entity, entityToTravelTo, distance);
     }
 
-    public @Nullable Path getEntityPathToXYZ(Entity entity, int x, int y, int z, float distance)
-    {
-        int eBlockX = MathHelper.floor(entity.x);
-        int eBlockY = MathHelper.floor(entity.y);
-        int eBlockZ = MathHelper.floor(entity.z);
-        int cacheRadius = (int)(distance + 8F);
-        int cacheMinX = eBlockX - cacheRadius;
-        int cacheMinY = eBlockY - cacheRadius;
-        int cacheMinZ = eBlockZ - cacheRadius;
-        int cacheMaxX = eBlockX + cacheRadius;
-        int cacheMaxY = eBlockY + cacheRadius;
-        int cacheMaxZ = eBlockZ + cacheRadius;
-        ChunkCache chunkcache = new ChunkCache(this, cacheMinX, cacheMinY, cacheMinZ, cacheMaxX, cacheMaxY, cacheMaxZ);
-        return (new PathFinder(chunkcache)).findPath(entity, x, y, z, distance);
+    public @Nullable Path getEntityPathToTilePos(final @NotNull Entity entity, final @NotNull TilePos tilePos, final float distance) {
+        final @NotNull TilePos entityPos = new TilePos(entity);
+        final int cacheRadius = (int) (distance + 8F);
+        final @NotNull TilePos cacheMin = entityPos.sub(cacheRadius, cacheRadius, cacheRadius);
+        final @NotNull TilePos cacheMax = entityPos.add(cacheRadius, cacheRadius, cacheRadius);
+
+        final @NotNull ChunkCache cache = new ChunkCache(this, cacheMin.x, cacheMin.y, cacheMin.z, cacheMax.x, cacheMax.y, cacheMax.z);
+        return new PathFinder(cache).findPath(entity, tilePos.x, tilePos.y, tilePos.z, distance);
     }
 
-    public boolean getDirectSignal(int x, int y, int z, Side side) {
-        Block<?> block = getBlock(x, y, z);
-        if (block == null) return false;
-        return block.getDirectSignal(this, x, y, z, side);
+    @Deprecated
+    public final @Nullable Path getEntityPathToXYZ(final @NotNull Entity entity, final int x, final int y, final int z, final float distance) {
+        return this.getEntityPathToTilePos(entity, new TilePos(x, y, z), distance);
     }
 
-    public boolean hasDirectSignal(int x, int y, int z) {
-        for (Side side : Side.sides){
-            if (getDirectSignal(
-                x + side.getOffsetX(),
-                y + side.getOffsetY(),
-                z + side.getOffsetZ(),
-                side))
-            {
+    public boolean hasDirectSignal(final @NotNull TilePos tilePos, final @NotNull Side side) {
+        final @Nullable Block<?> block = this.getBlock(tilePos);
+        return block != null && block.getDirectSignal(this, tilePos.x, tilePos.y, tilePos.z, side);
+    }
+
+    @Deprecated
+    public final boolean getDirectSignal(final int x, final int y, final int z, final @NotNull Side side) {
+        return this.hasDirectSignal(new TilePos(x, y, z), side);
+    }
+
+    public boolean hasDirectSignal(final @NotNull TilePos tilePos) {
+        for (final @NotNull Side side : Side.sides) {
+            if (this.hasDirectSignal(tilePos.add(side.getDirection()), side)) {
                 return true;
             }
         }
+
         return false;
     }
 
-    public boolean getSignal(int x, int y, int z, Side side) {
-        Block<?> block = getBlock(x, y, z);
-        if(isBlockNormalCube(x, y, z) && block != Blocks.BLOCK_REDSTONE  && block != Blocks.PUMPKIN_REDSTONE && block != Blocks.MATCHER_ACTIVE) {
-            return hasDirectSignal(x, y, z);
+    @Deprecated
+    public final boolean hasDirectSignal(final int x, final int y, final int z) {
+        return this.hasDirectSignal(new TilePos(x, y, z));
+    }
+
+    public boolean hasSignal(final @NotNull TilePos tilePos, final @NotNull Side side) {
+        final @Nullable Block<?> block = this.getBlock(tilePos);
+        if (this.isBlockNormalCube(tilePos) && block != Blocks.BLOCK_REDSTONE && block != Blocks.PUMPKIN_REDSTONE && block != Blocks.MATCHER_ACTIVE) {
+            return this.hasDirectSignal(tilePos);
         }
-        if(block == null) {
+        if (block == null) {
             return false;
         }
 
-        if (block == Blocks.PUMPKIN_REDSTONE) { // TODO make actual block methods to handle sided-ness
-            return pumpkinHasDirectSignal(x, y, z) || block.getSignal(this, x, y, z, side);
+        if (block == Blocks.PUMPKIN_REDSTONE) {
+            return this.pumpkinHasDirectSignal(tilePos) || block.getSignal(this, tilePos.x, tilePos.y, tilePos.z, side);
         } else {
-            return block.getSignal(this, x, y, z, side);
+            return block.getSignal(this, tilePos.x, tilePos.y, tilePos.z, side);
         }
     }
+
+    @Deprecated
+    public final boolean getSignal(final int x, final int y, final int z, final @NotNull Side side) {
+        return this.hasSignal(new TilePos(x, y, z), side);
+    }
+
     // Special version of hasDirectSignal that excludes the front side of the redstone lantern.
-    private boolean pumpkinHasDirectSignal(int x, int y, int z) {
-        for (Side side : Side.sides) {
-            if(Side.getSideById(getBlockMetadata(x, y, z)) == side) continue;
-            if (getDirectSignal(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ(), side)) {
+    private boolean pumpkinHasDirectSignal(final @NotNull TilePos tilePos) {
+        for (final @NotNull Side side : Side.sides) {
+            if (Side.getSideById(this.getBlockData(tilePos)) == side) {
+                continue;
+            }
+            if (this.hasDirectSignal(tilePos.add(side.getDirection()), side)) {
                 return true;
             }
         }
@@ -2715,21 +2643,21 @@ public class World implements WorldSource {
         return false;
     }
 
-
-    public boolean hasNeighborSignal(int x, int y, int z) {
-        for (Side side : Side.sides){
-            if (getSignal(
-                x + side.getOffsetX(),
-                y + side.getOffsetY(),
-                z + side.getOffsetZ(),
-                side))
-            {
+    public boolean hasNeighborSignal(final @NotNull TilePos tilePos) {
+        for (final @NotNull Side side : Side.sides) {
+            if (this.hasSignal(tilePos.add(side.getDirection()), side)) {
                 return true;
             }
         }
+
         return false;
     }
 
+    @Deprecated
+    public final boolean hasNeighborSignal(final int x, final int y, final int z) {
+        return this.hasNeighborSignal(new TilePos(x, y, z));
+    }
+
     public Player getClosestPlayerToEntity(Entity entity, double radius)
     {
         return getClosestPlayer(entity.x, entity.y, entity.z, radius);
@@ -2965,11 +2893,15 @@ public class World implements WorldSource {
         }
     }
 
-    public boolean canMineBlock(final Player player, final int x, final int y, final int z)
-    {
+    public boolean canMineBlock(final @NotNull Player player, final @NotNull TilePos tilePos) {
         return true;
     }
 
+    @Deprecated
+    public final boolean canMineBlock(final @NotNull Player player, final int x, final int y, final int z) {
+        return this.canMineBlock(player, new TilePos(x, y, z));
+    }
+
     public void sendTrackedEntityStatusUpdatePacket(Entity entityId, byte entityStatus)
     {
     }
@@ -3035,14 +2967,17 @@ public class World implements WorldSource {
         return chunkProvider;
     }
 
-    public void triggerEvent(int x, int y, int z, int index, int data)
-    {
-        int j1 = getBlockId(x, y, z);
-        if(j1 > 0)
-        {
-            Blocks.blocksList[j1].triggerEvent(this, x, y, z, index, data);
+    public void triggerEvent(final @NotNull TilePos tilePos, final int index, final int data) {
+        final @Nullable Block<?> block = this.getBlock(tilePos);
+        if (block != null) {
+            block.triggerEvent(this, tilePos.x, tilePos.y, tilePos.z, index, data);
         }
     }
+
+    @Deprecated
+    public final void triggerEvent(final int x, final int y, final int z, final int index, final int data) {
+        this.triggerEvent(new TilePos(x, y, z), index, data);
+    }
     
     public LevelStorage getSaveHandler()
     {
@@ -3100,32 +3035,31 @@ public class World implements WorldSource {
         }
     }
 
-    public boolean canBlockBeRainedOn(int x, int y, int z)
-    {
-        if(getCurrentWeather() == null)
-        {
+    public boolean isBlockBeingRainedOn(final @NotNull TilePos tilePos) {
+        if (
+            this.getCurrentWeather() == null ||
+            !(this.getCurrentWeather() instanceof IPrecipitation) ||
+            !this.canBlockSeeSky(tilePos) ||
+            this.getHeightValue(tilePos.x, tilePos.z) > tilePos.y
+        ) {
             return false;
         }
-        if (!(getCurrentWeather() instanceof IPrecipitation))
-        {
-            return false;
-        }
-        if(!canBlockSeeTheSky(x, y, z))
-        {
-            return false;
-        }
-        if(getHeightValue(x, z) > y)
-        {
-            return false;
-        }
-        Biome biome = getBlockBiome(x, y, z);
-        for (int q = 0; q < biome.blockedWeathers.length; q++)
-        {
-            if (biome.blockedWeathers[q] == getCurrentWeather()) return false;
+
+        final @NotNull Biome biome = this.getBlockBiome(tilePos);
+        for (final @NotNull Weather weather : biome.blockedWeathers) {
+            if (weather == this.getCurrentWeather()) {
+                return false;
+            }
         }
+
         return true;
     }
 
+    @Deprecated
+    public final boolean canBlockBeRainedOn(final int x, final int y, final int z) {
+        return this.isBlockBeingRainedOn(new TilePos(x, y, z));
+    }
+
     public void setSavedData(String id, SavedData savedData)
     {
         savedDataStorage.set(id, savedData);
